package gregapi.block.multitileentity.example;

import static gregapi.data.CS.*;
import static org.lwjgl.opengl.GL11.*;
import static org.lwjgl.opengl.GL12.GL_RESCALE_NORMAL;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_AddToolTips;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetBlockHardness;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetCollisionBoundingBoxFromPool;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetComparatorInputOverride;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetExplosionResistance;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetFireSpreadSpeed;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetFlammability;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetSelectedBoundingBoxFromPool;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetSubItems;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnPlaced;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnRegistrationClient;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnToolClick;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SetBlockBoundsBasedOnState;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataByte;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataByteArray;
import gregapi.block.multitileentity.*;
import gregapi.data.MD;
import gregapi.data.MT;
import gregapi.gui.ContainerClientChest;
import gregapi.gui.ContainerCommonChest;
import gregapi.network.INetworkHandler;
import gregapi.network.IPacket;
import gregapi.oredict.OreDictMaterial;
import gregapi.render.ITexture;
import gregapi.tileentity.ITileEntityAdjacentInventoryUpdatable;
import gregapi.tileentity.base.TileEntityBase05Inventories;
import gregapi.tileentity.data.ITileEntitySurface;
import gregapi.tileentity.delegate.DelegatorTileEntity;
import gregapi.util.UT;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import net.minecraft.block.Block;
import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.RenderBlocks;
import net.minecraft.client.renderer.tileentity.TileEntityRendererDispatcher;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.WeightedRandomChestContent;
import net.minecraft.world.World;
import net.minecraftforge.common.ChestGenHooks;
import cpw.mods.fml.client.registry.ClientRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 * 
 * An example implementation of a Chest with my MultiTileEntity System.
 */
public class MultiTileEntityChest extends TileEntityBase05Inventories implements ITileEntitySurface, IMTE_OnRegistrationClient, IMTE_SyncDataByte, IMTE_AddToolTips, IMTE_SetBlockBoundsBasedOnState, IMTE_GetSubItems, IMTE_GetFlammability, IMTE_GetFireSpreadSpeed, IMTE_SyncDataByteArray, IMTE_GetExplosionResistance, IMTE_GetBlockHardness, IMTE_GetComparatorInputOverride, IMTE_GetSelectedBoundingBoxFromPool, IMTE_GetCollisionBoundingBoxFromPool, IMTE_OnPlaced, IMTE_OnToolClick {
	protected boolean mIsPainted = F;
	protected int mRGBa = UNCOLORED;
	protected byte mFacing = 3, mUsingPlayers = 0, oUsingPlayers = 0;
	protected float mLidAngle = 0, oLidAngle = 0, mHardness = 3.0F, mResistance = 3.0F;
	protected OreDictMaterial mMaterial = MT.NULL;
	
	/** Gets supplied via Default NBT. */
	public String mTextureName = "", mDungeonLootName = "";
	
	public MultiTileEntityChest() {/**/}
	
    @Override
    public void readFromNBT2(NBTTagCompound aNBT) {
        super.readFromNBT2(aNBT);
        if (aNBT.hasKey(NBT_COLOR)) mRGBa = aNBT.getInteger(NBT_COLOR);
        if (aNBT.hasKey(NBT_FACING)) mFacing = aNBT.getByte(NBT_FACING);
        if (aNBT.hasKey(NBT_PAINTED)) mIsPainted = aNBT.getBoolean(NBT_PAINTED);
        if (aNBT.hasKey(NBT_TEXTURE)) mTextureName = aNBT.getString(NBT_TEXTURE);
        if (aNBT.hasKey("gt.dungeonloot")) mDungeonLootName = aNBT.getString("gt.dungeonloot");
        if (aNBT.hasKey(NBT_HARDNESS)) mHardness = aNBT.getFloat(NBT_HARDNESS);
        if (aNBT.hasKey(NBT_RESISTANCE)) mResistance = aNBT.getFloat(NBT_RESISTANCE);
        if (aNBT.hasKey(NBT_MATERIAL)) mMaterial = OreDictMaterial.get(aNBT.getString(NBT_MATERIAL));
    }
    
    @Override
    public void writeToNBT2(NBTTagCompound aNBT) {
        super.writeToNBT2(aNBT);
        aNBT.setByte(NBT_FACING, mFacing);
    	if (UT.Code.stringValid(mDungeonLootName)) aNBT.setString("gt.dungeonloot", mDungeonLootName);
    }
    
    @Override
    public boolean onTickCheck(long aTimer) {
    	return mUsingPlayers != oUsingPlayers || super.onTickCheck(aTimer);
    }
    
	@Override
    public void onTickResetChecks(long aTimer, boolean aIsServerSide) {
    	super.onTickResetChecks(aTimer, aIsServerSide);
		oUsingPlayers = mUsingPlayers;
    }
	
	@Override
	public IPacket getClientDataPacket(boolean aSendAll) {
		if (aSendAll) return getClientDataPacketByteArray(aSendAll, mFacing, mUsingPlayers, (byte)getSizeInventory(), (byte)UT.Code.getR(mRGBa), (byte)UT.Code.getG(mRGBa), (byte)UT.Code.getB(mRGBa));
		return getClientDataPacketByte(aSendAll, mUsingPlayers);
	}
	
	@Override
	public boolean onPlaced(ItemStack aStack, EntityPlayer aPlayer, MultiTileEntityContainer aMTEContainer, World aWorld, int aX, int aY, int aZ, byte aSide, float aHitX, float aHitY, float aHitZ) {
        mFacing = UT.Code.getSideForPlayerPlacing(aPlayer, mFacing, SIDES_HORIZONTAL);
		return T;
	}
	
    @Override
    public void onTick(long aTimer, boolean aIsServerSide) {
    	super.onTick(aTimer, aIsServerSide);
        if (isServerSide()) {
            if (mInventoryChanged) {
            	for (byte tSide : ALL_SIDES_VALID) {
            		DelegatorTileEntity<TileEntity> tDelegator = getAdjacentTileEntity(tSide);
            		if (tDelegator.mTileEntity instanceof ITileEntityAdjacentInventoryUpdatable) {
            			((ITileEntityAdjacentInventoryUpdatable)tDelegator.mTileEntity).adjacentInventoryUpdated(tDelegator.mSideOfTileEntity, this);
            		}
            	}
            }
            if (mUsingPlayers > 0 && aTimer % 1200 == 0) mUsingPlayers = UT.Code.bind7(getOpenGUIs());
        }
        oLidAngle = mLidAngle;
        if (mUsingPlayers > 0 && mLidAngle == 0.0F) worldObj.playSoundEffect(xCoord + 0.5D, yCoord + 0.5D, zCoord + 0.5D, "random.chestopen", 0.5F, worldObj.rand.nextFloat() * 0.1F + 0.9F);
        if (mUsingPlayers == 0 && mLidAngle > 0.0F || mUsingPlayers > 0 && mLidAngle < 1.0F) {
            if (mUsingPlayers > 0) mLidAngle += 0.1F; else mLidAngle -= 0.1F;
            if (mLidAngle > 1.0F) mLidAngle = 1.0F; else if (mLidAngle < 0.0F) mLidAngle = 0.0F;
            if (mLidAngle < 0.5F && oLidAngle >= 0.5F) worldObj.playSoundEffect(xCoord + 0.5D, yCoord + 0.5D, zCoord + 0.5D, "random.chestclosed", 0.5F, worldObj.rand.nextFloat() * 0.1F + 0.9F);
        }
    }
    
	@Override
	public long onToolClick(String aTool, long aRemainingDurability, long aQuality, Entity aPlayer, List<String> aChatReturn, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, byte aSide, float aHitX, float aHitY, float aHitZ) {
		if (isClientSide()) return 0;
		if (aTool.equals(TOOL_wrench)) {byte aTargetSide = UT.Code.getSideWrenching(aSide, aHitX, aHitY, aHitZ); if (aTargetSide > 1) {mFacing = aTargetSide; updateClientData(); causeBlockUpdate(); return 10000;}}
		return 0;
	}
	
    @Override
	public boolean onBlockActivated2(EntityPlayer aPlayer, byte aSide, float aHitX, float aHitY, float aHitZ) {
		if (isServerSide() && !worldObj.isSideSolid(xCoord, yCoord + 1, zCoord, FORGE_DIR[SIDE_BOTTOM]) && isUseableByPlayerGUI(aPlayer)) {
			generateDungeonLoot();
			openGUI(aPlayer);
		}
		return true;
	}
    
    @Override
    public boolean breakBlock() {
		generateDungeonLoot();
    	return super.breakBlock();
    }
	
	@Override public int getFireSpreadSpeed(byte aSide) {return 0;}
	@Override public int getFlammability(byte aSide) {return 0;}
	@Override public boolean canDrop(int aInventorySlot) {return true;}
	@Override public String getTileEntityName() {return "gt.multitileentity.chest";}
    @Override public void openInventoryGUI () {mUsingPlayers++;}
    @Override public void closeInventoryGUI() {mUsingPlayers--;}
	@Override public float getExplosionResistance(Entity aExploder, double aExplosionX, double aExplosionY, double aExplosionZ) {return getExplosionResistance();}
	@Override public float getExplosionResistance() {return mResistance;}
	@Override public float getBlockHardness() {return mHardness;}
	@Override public int getComparatorInputOverride(byte aSide) {return Container.calcRedstoneFromInventory(this);}
	@Override public ITexture getTexture(Block aBlock, int aRenderPass, byte aSide, boolean[] aShouldSideBeRendered) {return null;}
	@Override public int getRenderPasses(Block aBlock, boolean[] aShouldSideBeRendered) {return 0;}
	@Override public boolean renderBlock(Block aBlock, RenderBlocks aRenderer) {return true;}
	
	protected void generateDungeonLoot() {
		if (isServerSide() && UT.Code.stringValid(mDungeonLootName)) {
			WeightedRandomChestContent.generateChestContents(worldObj.rand, ChestGenHooks.getItems(mDungeonLootName, worldObj.rand), this, ChestGenHooks.getCount(mDungeonLootName, worldObj.rand));
			mDungeonLootName = "";
		}
	}
	
	@Override
	public boolean getSubItems(MultiTileEntityBlockInternal aBlock, Item aItem, CreativeTabs aTab, List aList, short aID) {
		if (D1) for (String tLoot : new String[] {"mineshaftCorridor", "pyramidDesertyChest", "pyramidJungleChest", "pyramidJungleDispenser", "strongholdCorridor", "strongholdLibrary", "strongholdCrossing", "villageBlacksmith", "bonusChest", "dungeonChest"}) aList.add(aBlock.mMultiTileEntityRegistry.getItem(aID, UT.NBT.getNBTString(null, "gt.dungeonloot", tLoot)));
		return T;
	}
	
	@Override
	public void addToolTips(List aList, ItemStack aStack, boolean aF3_H) {
		if (aStack.getTagCompound() != null && aStack.getTagCompound().hasKey("gt.dungeonloot")) aList.add("Dungeon Loot: "+aStack.getTagCompound().getString("gt.dungeonloot"));
	}
	
	@Override public boolean receiveDataByte(byte aData, INetworkHandler aNetworkHandler) {mUsingPlayers = aData; worldObj.markBlockForUpdate(xCoord, yCoord, zCoord); return true;}
	
	@Override
	public boolean receiveDataByteArray(byte[] aData, INetworkHandler aNetworkHandler) {
		mFacing = (byte)(aData[0] & 7);
		mUsingPlayers = aData[1];
		if (UT.Code.unsignB(aData[2]) != getSizeInventory()) setInventory(new ItemStack[UT.Code.unsignB(aData[2])]);
		mRGBa = UT.Code.getRGBInt(new short[] {UT.Code.unsignB(aData[3]), UT.Code.unsignB(aData[4]), UT.Code.unsignB(aData[5])});
		return true;
	}
	
	@Override public boolean unpaint() {if (mIsPainted) {mIsPainted=F; mRGBa=UT.Code.getRGBInt(mMaterial.mRGBaSolid); return T;} return F;}
	@Override public boolean isPainted() {return mIsPainted || (worldObj != null && isClientSide() && UT.Code.getRGBInt(mMaterial.mRGBaSolid) != mRGBa);}
	@Override public boolean paint(int aRGB) {if (aRGB!=mRGBa) {mRGBa=aRGB; mIsPainted=T; return T;} return F;}
	@Override public int getPaint() {return mRGBa;}
	
    private static final float minX = 0.0625F, minY = 0F, minZ = 0.0625F, maxX = 0.9375F, maxY = 0.875F, maxZ = 0.9375F;
    @Override public AxisAlignedBB getCollisionBoundingBoxFromPool() {return AxisAlignedBB.getBoundingBox(xCoord + minX, yCoord + minY, zCoord + minZ, xCoord + maxX, yCoord + maxY, zCoord + maxZ);}
    @Override public AxisAlignedBB getSelectedBoundingBoxFromPool () {return AxisAlignedBB.getBoundingBox(xCoord + minX, yCoord + minY, zCoord + minZ, xCoord + maxX, yCoord + maxY, zCoord + maxZ);}
    @Override public void setBlockBoundsBasedOnState(Block aBlock) {aBlock.setBlockBounds(minX, minY, minZ, maxX, maxY, maxZ);}
	@Override public boolean setBlockBounds(Block aBlock, int aRenderPass, boolean[] aShouldSideBeRendered) {aBlock.setBlockBounds(minX, minY, minZ, maxX, maxY, maxZ); return true;}
	@Override public float getSurfaceSize    		(byte aSide) {return 0.875F;}
	@Override public float getSurfaceSizeAttachable	(byte aSide) {return 0.875F;}
	@Override public float getSurfaceDistance		(byte aSide) {return aSide > 1 ? 0.0625F : aSide == 1 ? 0.125F : 0;}
	@Override public boolean isSurfaceSolid  		(byte aSide) {return false;}
	@Override public boolean isSurfaceOpaque 		(byte aSide) {return false;}
	
	@Override public Object getGUIClient(int aGUIID, EntityPlayer aPlayer) {return new ContainerClientChest(aPlayer.inventory, this);}
	@Override public Object getGUIServer(int aGUIID, EntityPlayer aPlayer) {return new ContainerCommonChest(aPlayer.inventory, this);}
	
	@Override
	public boolean renderItem(Block aBlock, RenderBlocks aRenderer) {
        TileEntityRendererDispatcher.instance.renderTileEntityAt(this, 0.0D, 0.0D, 0.0D, 0.0F);
		return true;
	}
	
	@SideOnly(Side.CLIENT)
	private static MultiTileEntityRendererChest RENDERER;
	
	@Override
	@SideOnly(Side.CLIENT)
	public void onRegistrationClient(MultiTileEntityRegistry aRegistry, short aID) {
		if (RENDERER == null) ClientRegistry.bindTileEntitySpecialRenderer(getClass(), RENDERER = new MultiTileEntityRendererChest());
		RENDERER.mResources.put(mTextureName, new ResourceLocation[] {new ResourceLocation(MD.GT.mID, TEX_DIR_MODEL + aRegistry.mNameInternal + "/" + mTextureName + ".colored.png"), new ResourceLocation(MD.GT.mID, TEX_DIR_MODEL + aRegistry.mNameInternal + "/" + mTextureName + ".plain.png")});
	}
	
	@SideOnly(Side.CLIENT)
	public static class MultiTileEntityRendererChest extends TileEntitySpecialRenderer {
	    private static final MultiTileEntityModelChest sModel = new MultiTileEntityModelChest();
		public final Map<String, ResourceLocation[]> mResources = new HashMap<String, ResourceLocation[]>();
		
		@Override
		public void renderTileEntityAt(TileEntity aTileEntity, double aX, double aY, double aZ, float aPartialTick) {
	        if (aTileEntity instanceof MultiTileEntityChest) {
	        	ResourceLocation[] tLocation = mResources.get(((MultiTileEntityChest)aTileEntity).mTextureName);
		        bindTexture(tLocation[0]);
		        glPushMatrix();
		        glEnable(GL_RESCALE_NORMAL);
		        short[] tRGBa = UT.Code.getRGBaArray(((MultiTileEntityChest)aTileEntity).mRGBa);
		        glColor4f(tRGBa[0] / 256.0F, tRGBa[1] / 256.0F, tRGBa[2] / 256.0F, 1.0F);
		        glTranslatef((float)aX, (float)aY + 1.0F, (float)aZ + 1.0F);
		        glScalef(1.0F, -1.0F, -1.0F);
		        glTranslatef(0.5F, 0.5F, 0.5F);
		        switch(((MultiTileEntityChest)aTileEntity).mFacing) {
		        case  2: glRotatef(180, 0.0F, 1.0F, 0.0F); break;
		        case  4: glRotatef( 90, 0.0F, 1.0F, 0.0F); break;
		        case  5: glRotatef(-90, 0.0F, 1.0F, 0.0F); break;
		        default: glRotatef(  0, 0.0F, 1.0F, 0.0F); break;
		        }
		        glTranslatef(-0.5F, -0.5F, -0.5F);
		        float tLidAngle = 1.0F - (((MultiTileEntityChest)aTileEntity).oLidAngle + (((MultiTileEntityChest)aTileEntity).mLidAngle - ((MultiTileEntityChest)aTileEntity).oLidAngle) * aPartialTick);
		        tLidAngle = -(((1.0F - tLidAngle*tLidAngle*tLidAngle) * 3.141593F) / 2.0F);
		        sModel.render(tLidAngle);
		        glDisable(GL_RESCALE_NORMAL);
		        glPopMatrix();
		        glEnable(GL_RESCALE_NORMAL);
		        glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		        
		        bindTexture(tLocation[1]);
		        glPushMatrix();
		        glTranslatef((float)aX, (float)aY + 1.0F, (float)aZ + 1.0F);
		        glScalef(1.0F, -1.0F, -1.0F);
		        glTranslatef(0.5F, 0.5F, 0.5F);
		        switch(((MultiTileEntityChest)aTileEntity).mFacing) {
		        case  2: glRotatef(180, 0.0F, 1.0F, 0.0F); break;
		        case  4: glRotatef( 90, 0.0F, 1.0F, 0.0F); break;
		        case  5: glRotatef(-90, 0.0F, 1.0F, 0.0F); break;
		        default: glRotatef(  0, 0.0F, 1.0F, 0.0F); break;
		        }
		        glTranslatef(-0.5F, -0.5F, -0.5F);
		        sModel.render(tLidAngle);
		        glDisable(GL_RESCALE_NORMAL);
		        glPopMatrix();
                glEnable(GL_RESCALE_NORMAL);
	        }
	    }
	}
	
	@SideOnly(Side.CLIENT)
	public static class MultiTileEntityModelChest extends ModelBase {
	    private final ModelRenderer mLid, mBottom, mKnob;
	    
	    public MultiTileEntityModelChest() {
	    	mLid = (new ModelRenderer(this, 0, 0)).setTextureSize(64, 64);
	        mLid.addBox(0.0F, -5.0F, -14.0F, 14, 5, 14, 0.0F);
	        mLid.rotationPointX =  1.0F;
	        mLid.rotationPointY =  7.0F;
	        mLid.rotationPointZ = 15.0F;
	        mKnob = (new ModelRenderer(this, 0, 0)).setTextureSize(64, 64);
	        mKnob.addBox(-1.0F, -2.0F, -15.0F, 2, 4, 1, 0.0F);
	        mKnob.rotationPointX =  8.0F;
	        mKnob.rotationPointY =  7.0F;
	        mKnob.rotationPointZ = 15.0F;
	        mBottom = (new ModelRenderer(this, 0, 19)).setTextureSize(64, 64);
	        mBottom.addBox(0.0F, 0.0F, 0.0F, 14, 10, 14, 0.0F);
	        mBottom.rotationPointX = 1.0F;
	        mBottom.rotationPointY = 6.0F;
	        mBottom.rotationPointZ = 1.0F;
	    }
	    
	    public void render(float aLidAngle) {
	        mKnob.rotateAngleX = mLid.rotateAngleX = aLidAngle;
	        mLid.render(0.0625F);
	        mKnob.render(0.0625F);
	        mBottom.render(0.0625F);
	    }
	}
}