package gregapi.tileentity.energy;

import static gregapi.data.CS.*;
import gregapi.data.LH;
import gregapi.data.TD;
import gregapi.tileentity.machines.ITileEntitySwitchableOnOff;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.item.ItemStack;

public abstract class TileEntityBase11Bipolar extends TileEntityBase10EnergyConverter implements ITileEntitySwitchableOnOff {
	@Override
	public void addToolTipsEfficiency(List aList, ItemStack aStack, boolean aF3_H) {
		if (TD.Energy.ALL_EU.contains(mEnergyTypeAccepted)) {
			if (TD.Energy.ALL_EU.contains(mEnergyTypeEmitted)) {
				aList.add(LH.getToolTipEfficiency(UT.Code.units(10000, mInput, mOutput*2, F)));
			} else {
				if (mEnergyTypeEmitted == TD.Energy.RF) aList.add(LH.getToolTipEfficiency(UT.Code.units(10000, mInput*4, mOutput*2, F)));
			}
		} else {
			if (TD.Energy.ALL_EU.contains(mEnergyTypeEmitted) && mEnergyTypeAccepted == TD.Energy.RF) aList.add(LH.getToolTipEfficiency(UT.Code.units(10000, mInput, mOutput*8, F)));
		}
	}
	
    @Override
    public void doConversion(long aTimer) {
    	long tOutput = UT.Code.units(mEnergy, mInput, mOutput, F), tMaxOut = getEnergySizeOutputMax(mEnergyTypeEmitted, SIDE_ANY);
    	mActive = (tOutput >= getEnergySizeOutputMin(mEnergyTypeEmitted, SIDE_ANY));
		mEmitsEnergy = F;
    	
    	if (mActive) {
			if (tOutput > tMaxOut && TD.Energy.ALL_COMSUMPTION_LIMITED.contains(mEnergyTypeAccepted)) tOutput = tMaxOut;
    		if (tOutput > tMaxOut) {
    			overcharge(mEnergy, mEnergyTypeEmitted);
    		} else {
				if (TD.Energy.ALL_SIZE_IRRELEVANT.contains(mEnergyTypeEmitted)) {
					long
					tEmittedPackets = ITileEntityEnergy.Util.emitEnergyToSide(mEnergyTypeEmitted,           mFacing , 1, tOutput*mMultiplier, this);
					if (!mWasteEnergy) mEnergy -= UT.Code.units(tEmittedPackets, mOutput*mMultiplier, mInput, T);
					mEmitsEnergy = (tEmittedPackets > 0);
					tEmittedPackets = ITileEntityEnergy.Util.emitEnergyToSide(mEnergyTypeEmitted, OPPOSITES[mFacing], 1, tOutput*mMultiplier, this);
					if (!mWasteEnergy) mEnergy -= UT.Code.units(tEmittedPackets, mOutput*mMultiplier, mInput, T);
					mEmitsEnergy = (tEmittedPackets > 0 || mEmitsEnergy);
				} else {
					long
					tEmittedPackets = ITileEntityEnergy.Util.emitEnergyToSide(mEnergyTypeEmitted,           mFacing ,  tOutput, mMultiplier, this);
					if (!mWasteEnergy) mEnergy -= UT.Code.units(tEmittedPackets * tOutput, mOutput*mMultiplier, mInput, T);
					mEmitsEnergy = (tEmittedPackets > 0);
					tEmittedPackets = ITileEntityEnergy.Util.emitEnergyToSide(mEnergyTypeEmitted, OPPOSITES[mFacing], -tOutput, mMultiplier, this);
					if (!mWasteEnergy) mEnergy -= UT.Code.units(tEmittedPackets * tOutput, mOutput*mMultiplier, mInput, T);
					mEmitsEnergy = (tEmittedPackets > 0 || mEmitsEnergy);
				}
    		}
    	}
		if (mWasteEnergy) mEnergy = Math.max(0, mEnergy-getEnergySizeInputMax(mEnergyTypeAccepted, SIDE_ANY));
    }
    
	@Override public boolean isInput (byte aSide) {return !ALONG_AXIS[aSide][mFacing];}
	@Override public boolean isOutput(byte aSide) {return  ALONG_AXIS[aSide][mFacing];}
	@Override public String getLocalisedInputSide () {return LH.get(LH.FACE_ANYBUT_FRONT_BACK);}
	@Override public String getLocalisedOutputSide() {return LH.get(LH.FACE_FRONT_BACK);}
}